> ## Documentation Index
> Fetch the complete documentation index at: https://docs.toku.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Bulk Add Grants

> Bulk-creates ACCEPTED grants from rows keyed by roleInOrgExternalID, then generates vestings and template lockups.

Not available to API keys yet. It will need `grants:write`.

## OpenAPI

````yaml api-reference/openapi.json POST /tga/bulk-add-grants
openapi: 3.1.0
info:
  title: Toku API
  version: 1.0.0
servers:
  - url: https://api.toku.com
security:
  - bearerAuth: []
paths:
  /tga/bulk-add-grants:
    post:
      operationId: bulkAddGrants
      summary: Bulk Add Grants
      description: >-
        Bulk-creates ACCEPTED grants from rows keyed by roleInOrgExternalID,
        then generates vestings and template lockups.


        Not available to API keys yet. It will need `grants:write`.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkAddGrantsRequest'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BulkAddGrantsResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
        '404':
          description: Not found
        '409':
          description: Conflict
        '429':
          description: Response 429
components:
  schemas:
    BulkAddGrantsRequest:
      type: array
      items:
        type: object
        properties:
          roleInOrgExternalID:
            type: string
          tokenTypeID:
            type: string
            format: uuid
          grantName:
            type: string
          grantDescription:
            type: string
          grantConfigurationName:
            type: string
          grantConfigurationID:
            type: string
          isExercisable:
            type: boolean
          grantAmount: {}
          grantAmountInFiat: {}
          vestingFrequencyType:
            type: string
            enum:
              - MONTHLY
              - QUARTERLY
              - SEMIANNUALLY
              - YEARLY
              - CUSTOM
              - DAILY
              - WEEKLY
          vestingPeriods: {}
          vestingCliffPeriods:
            type: number
          vestingCliffPercentage: {}
          lockup:
            type: number
          vestingStartDate:
            type: string
            format: date-time
          offPlatformDate:
            type: string
            format: date-time
          isSection83bElectionEligible:
            type: boolean
          strikeDate:
            type: string
            format: date-time
          grantDate:
            type: string
            format: date-time
          averageBasis: {}
          allocationType:
            type: string
          currency:
            type: string
          taxCurrencyCode:
            type: string
            enum:
              - TRY
              - ILS
              - CRC
              - TTD
              - SGD
              - JPY
              - AUD
              - NOK
              - INR
              - GBP
              - CHF
              - RUB
              - CAD
              - BRL
              - NGN
              - KRW
              - AED
              - LBP
              - EUR
              - NZD
              - ZAR
              - USD
              - USDC
              - USDT
              - USDP
              - PHP
              - PLN
              - RSD
              - HKD
              - TWD
              - AFN
              - AMD
              - ANG
              - AOA
              - ARS
              - AWG
              - AZN
              - BAM
              - BBD
              - BDT
              - BGN
              - BHD
              - BIF
              - BMD
              - BND
              - BOB
              - BSD
              - BTN
              - BWP
              - BYN
              - BZD
              - CDF
              - CLF
              - CLP
              - CNY
              - COP
              - CUC
              - CUP
              - CVE
              - CZK
              - DJF
              - DKK
              - DOP
              - DZD
              - EGP
              - ERN
              - ETB
              - FJD
              - FKP
              - GEL
              - GHS
              - GIP
              - GMD
              - GNF
              - GTQ
              - GYD
              - HNL
              - HRK
              - HTG
              - HUF
              - IDR
              - IQD
              - IRR
              - ISK
              - JMD
              - JOD
              - KES
              - KGS
              - KHR
              - KMF
              - KPW
              - KWD
              - KYD
              - KZT
              - LAK
              - LKR
              - LRD
              - LSL
              - LYD
              - MAD
              - MDL
              - MGA
              - MKD
              - MMK
              - MNT
              - MOP
              - MRU
              - MUR
              - MVR
              - MWK
              - MXN
              - MYR
              - MZN
              - NAD
              - NPR
              - NIO
              - OMR
              - PAB
              - PEN
              - PGK
              - PKR
              - PYG
              - QAR
              - RON
              - RWF
              - SAR
              - SBD
              - SCR
              - SDG
              - SHP
              - SLL
              - SOS
              - SRD
              - SSP
              - STN
              - SVC
              - SYP
              - SZL
              - TJS
              - TMT
              - TND
              - TOP
              - TZS
              - UAH
              - UGX
              - UYU
              - UZS
              - VES
              - VND
              - VUV
              - WST
              - XAF
              - XCD
              - XOF
              - XPF
              - YER
              - ZMW
              - SEK
              - THB
          pricePerUnit: {}
          grantTemplateID:
            type: string
          grantAssetType:
            type: string
            enum:
              - TOKEN
              - FIAT
          isCashCompensation:
            type: string
        required:
          - roleInOrgExternalID
          - grantName
          - grantDescription
          - grantConfigurationName
          - grantConfigurationID
          - isExercisable
          - grantAmount
          - vestingFrequencyType
          - vestingPeriods
          - vestingCliffPeriods
          - vestingCliffPercentage
          - lockup
          - vestingStartDate
          - isSection83bElectionEligible
    BulkAddGrantsResponse:
      type: array
      items:
        type: string
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
````
